RESTART:

Cls
Clear
If MM.Ver < 4.0503 Then
 Print "THIS PROGRAM NEEDS A 4.5C FIRMWARE VERSION OR BETTER":Print
 End
EndIf

Mode 4

Library Load ".\psgmini\psgmini.lib"
Font Load ".\fnt\gauntnes.fnt" As #4

test=0
room=1
sprmax=106+32
softs=1
key=3: bomb=3
score=0

SAVEKE=2
SAVEPO=2
GETTRE=2
song=Rnd(Timer)*4+1

InitSound

psg=0
psgmusic=0
pwmmus=0: PWMChannel(2,1)
Dim st(34,34)

'PSGLibAni
'Cls
'Pause(200)
Silence

maxg=50 ' MAX ENEMIES IN SCREEN
ms=2    ' MAX SFX
Dim xe(maxg+3),ye(maxg+3)
Dim xh(maxg+3),yh(maxg+3)
Dim ae(maxg+3),te(maxg+3)
Dim ce(maxg+3),en(maxg+3)
Dim snd(ms+1),sndc(ms+1),sndspd(ms+1),sndmax(ms+1),sndmin(ms+1),vol(ms+1)
actg=0: cntg=maxg

If test>0 Then
 plname$="ELF": PTypeA=4
 Cmag=3: Csht=2: Cfig=2: Cshs=4: Carm=2: Cspd=4: CoP=2: MaxEn=820: hpg=120
 Sprite Load ".\spr\ingame2.spr": FirstLoad=0
 If test=2 Then GoTo start
 GoTo LoadScreen
Else
 Sprite Load ".\spr\gauntmx.spr"
EndIf

Sub PrintF(x,y,ca,cb,cc,st$)
 Local T,TT,co
 For T=-2 To 2
  Print@(x+t,y+3,1) CLR$(0);st$: Print@(x+3,y+t,1) CLR$(0);st$: Next t
 For T=-2 To 2 Step 2: For TT=-2 To 2 Step 2
  Print@(x+T,y+TT,1) CLR$(cc);st$: Next tt,t
 For T=-1 To 1 Step 2: For TT=-1 To 1 Step 2
  Print@(x+T,y+TT,1) CLR$(cb);st$: Next tt,t
 Print@(x,y,1) CLR$(ca);st$
End Sub

Sub VoiceOver(A$,V$)
 Color 7
 Line(88-Len(A$)*3-3,89)-(89+Len(A$)*3+3,100),0,BF
 Line(87-Len(A$)*3-3,88)-(90+Len(A$)*3+3,101),7,B
 Font #1: For T=0 To 1: Print @(89-Len(A$)*3,90+T,1) A$: Next T: Font #4
 If psgmusic=1 Then SetIntMusic(0): silence
 PlayRAW(".\raw\"+V$+".raw",0,1.7)
 If psgmusic=1 Then SetIntMusic(5): EnablePSG(1)
 mv=1:xa=0:xb=10:ya=0:yb=12:mapscan
End Sub

Sub IntSFX
 Local c,cc
 cSFX=cSFX+1: If cSFX>ms Then cSFX=1
 c = snd(cSFX)
 If c>20 Then
  cc = sndc(cSFX): PWM c,cc,cc: c=c+sndspd(cSFX)
  If c>sndmax(cSFX) And sndmax(cSFX)>0 Then c=1
  If c<sndmin(cSFX) And sndmin(cSFX)>0 Then c=1
 ElseIf c>0 And c<=20 Then
  c=0: Tone stop
 EndIf: snd(cSFX)=c
End Sub

Sub PlaySFX(snd,sndspd,sndmin,sndmax,sndc)
 Local t,ok
 ok=0
 For t=1 To ms
  If snd(t)=0 And ok=0 Then
   snd(t)=snd: sndspd(t)=sndspd
   sndmax(t)=sndmax: sndmin(t)=sndmin: sndc(t)=sndc: vol(t)=0: ok=1
  EndIf
 Next t
End Sub

Sub RedrawEnemies
 Local t
 For t=1 To maxg
 If ae(t)>0 Then
  If xe(t)>-16 And xe(t)<160 And ye(t)>-16 And ye(t)<MM.VRes-24 Then PutEnemy(t)
 EndIf
 Next t
End Sub

' OPEN DOORS
Sub OpenDoor(xd,yd)
 Local xt,yt,ok,t
 For t=1 To 2
  xt=xd: yt=yd: ok=1
  Do While ok=1
   ok=0
   If st(yt,xt)=54 Or st(yt,xt)=55 Then ok=1: st(yt,xt)=32
   If st(yt-1,xt)=54 Or st(yt-1,xt)=55 Then ok=1: st(yt-1,xt)=32: yt=yt-1
   If st(yt+1,xt)=54 Or st(yt+1,xt)=55 Then ok=1: st(yt+1,xt)=32: yt=yt+1
   If st(yt,xt+1)=54 Or st(yt,xt+1)=55 Then ok=1: st(yt,xt+1)=32: xt=xt+1
   If st(yt,xt-1)=54 Or st(yt,xt-1)=55 Then ok=1: st(yt,xt-1)=32: xt=xt-1
  Loop
 Next t
 start=2: x=xx: y=yy: mv=0: ya=0: yb=12: xa=0: xb=10: mapscan: start=0
End Sub

Sub CreateSprites(plname$)
 Local t,x,y
 Font #1: x=36:y=0
 Print@(x,y) CLR$(7);"      LOADING  PLAYER      "
 Open ".\spr\"+plname$+".spr" For input As #1
 Open ".\spr\ingame1.spr" For output As #2
 For t=1 To Lof(#1)/8
  a$=""
  If t=1 Then
   Line Input #1,a$: a$="' Player"+Chr$(10)
  ElseIf t=2 Then
   Line Input #1,a$: a$="16,"+Str$(106)+Chr$(10)
  Else
   a$=Input$(18,#1)
  EndIf
  If Eof(#1)=0 Then a$=a$+Chr$(13): Print #2,a$;
 Next t
 Close #1
 Print@(x,y) CLR$(7);"LOADING OBJECTS AND ENEMIES"
 Open ".\spr\nochange.spr" For input As #1
 a$=Input$(45,#1)
 Do While Eof(#1)=0
  Line Input #1,a$: Print #2,a$
 Loop
 Close #1: Close #2
End Sub

Sub CreateWalls(wallname$)
 Local t,x,y: Font #1: x=36:y=0
 Copy ".\spr\ingame1.spr" To ".\spr\ingame2.spr"
 Open ".\spr\ingame2.spr" For append As #2
 If FirstLoad=1 Then Print@(x,y) CLR$(7);"  LOADING TILES AND WALLS  "
 Open ".\walls\"+wallname$+".spr" For input As #1
 a$=Input$(46,#1)
 Do While Eof(#1)=0
  Line Input #1,a$: Print #2,a$
 Loop
 Close #1: Close #2
 If FirstLoad=1 Then Print@(x,y) CLR$(7);"        LOADING MAP        "
End Sub

INTRO:

Silence
LoadBMP(".\bmp\intro.bmp"): LoadVGM(".\vgm\title.vgm"): PlayVGM
ChangeSpeed(1): SetIntMusic(5)

co=1: st=0: Timer=0

Do While I$<>Chr$(32)
 I$=Inkey$
 If I$=Chr$(27) Then UnloadMusic: Mode 1: End
 co=co+1: If co>7 Then co=2
 yy=yy+1: If yy>6 Then yy=0
 sw=sw+1: If sw>3 Then sw=0
 If sa=0 Then sa=1 Else sa=0
 Sprite paste 1+sa,128,125: Sprite paste 3+sa,36,168: Sprite paste 5+sa,52,165
 For y=28+yy To 67 Step 7
  For x=26+sw To 211 Step 2
   If Pixel(x,y)>1 Then Pixel(x,y)=co
 Next x,y
 If Timer>30000 And st=0 Then StopMusic: Tone stop: st=1
Loop

UnloadMusic

SELECTION:

LoadBMP(".\bmp\select.bmp"): Font #4: MV=0
PlayRAW(".\raw\welcome.raw",1,1.4): LoadVGM(".\vgm\select.vgm"): PlayVGM
If pwmmus=0 Then
 ChangeSpeed(1): SetIntMusic(1)
Else
 SetIntMusic(4): PWMChannel(0,0)
EndIf
PtypeA=0:XC=0:YC=0
Do While I<>32 Or PTypeA=0
 I = KeyDown: If I=27 Then Mode 1: Silence: End
 If I=0 Then MV=0
 If MV=0 Then
  If I>=128 And I<=131 Then
   Tone 2000,2000,50
   For t=0 To 1
    Line(3+t,3+t)-(33-t,95-t),7,B: Line(3+t,119+t)-(33-t,211-t),7,B
    Line(205+t,119+t)-(235-t,211-t),7,B: Line(205+t,3+t)-(235-t,95-t),7,B
   Next t
  EndIf
  If I=128 Then YC=YC-1
  If I=129 Then YC=YC+1
  If I=130 Then XC=XC-1
  If I=131 Then XC=XC+1
  If XC<0 Then XC=0
  If XC>1 Then XC=1
  If YC<0 Then YC=0
  If YC>1 Then YC=1
  If XC=0 And YC=0 Then
   For t=0 To 1: Line(3+t,3+t)-(33-t,95-t),5,B: Next t: plname$="WARRIOR"
   PtypeA=1:CoP=4:Cmag=1:Csht=5:Cfig=4:Cshs=3.5:Carm=3:Cspd=2:MaxEn=980:hpg=80
  ElseIf XC=0 And YC=1 Then
   For t=0 To 1: Line(3+t,119+t)-(33-t,211-t),4,B: Next t: plname$="VALKYRIE"
   PtypeA=2:CoP=3:Cmag=2:Csht=2:Cfig=3:Cshs=3.5:Carm=4:Cspd=3:MaxEn=900:hpg=100
  ElseIf XC=1 And YC=1 Then
   For t=0 To 1: Line(205+t,119+t)-(235-t,211-t),4,B: Next t: plname$="WIZARD"
   PtypeA=3:CoP=6:Cmag=4:Csht=3:Cfig=1:Cshs=4:Carm=1:Cspd=2:MaxEn=800:hpg=100
  ElseIf XC=1 And YC=0 Then
   For t=0 To 1: Line(205+t,3+t)-(235-t,95-t),4,B: Next t: plname$="ELF"
   PtypeA=4:CoP=2:Cmag=3:Csht=2:Cfig=2:Cshs=4:Carm=2:Cspd=4:MaxEn=820:hpg=120
  EndIf
  If I>=128 And I<=131 Then MV=1
 EndIf
Loop

StopMusic: UnloadMusic: PlayRAW(".\raw\"+plname$+".raw",0,1.5): FirstLoad=1

LOADSCREEN:

Font #2
If FirstLoad=1 Then
 Cls: LoadBMP(".\bmp\loading.bmp"),0,3
 PrintF(30+34, 65+105,0,5,4,"ENTERING")
 PrintF(10+34, 90+105,0,5,4,"THE DUNGEON")
 CreateSprites(plname$)
Else
 A$=Str$(room): A$=Space$(3-Len(A$))+A$: Line(0,0)-(176,215),0,bf
 PrintF(36-Len(A$), 85,1,3,7,"LEVEL:"+A$)
 Font #1: Font Unload #4: Font Load ".\fnt\gauntnes.fnt" As #4
 Font #4: Color 7: Print @(241-8*Len(Str$(room)),29) room
EndIf

LoadVGM(".\vgm\start.vgm"): If pwmmus=0 Then PlayVGM: SetIntMusic(5)
t=Timer+2500

i=room
If i=1 Then a$="GREEWALL"
If i=2 Or i=3 Then a$="YELLWALL"
If i=4 Then a$="REDWALL"
If i=5 Then a$="PINKWALL"
If i=6 Then a$="WHITSOLI"
CreateWalls(a$)

'Do While (Timer<t)
'Loop
StopMusic: UnloadMusic
Sprite Unload: Sprite Load ".\spr\ingame2.spr"

GoTo START

' LOAD MAP
Sub LoadMap(File$)
 Local mx,my,t,A$,Tr
 Erase ST
 Tr=0
 Dim st(34,34): x=16: y=16: px=1: py=1
 Open File$ For Input As #1
 Line Input #1,A$
 For my=1 To 34
  For mx=1 To 38
   t=Asc(Input$(1,#1))
   If mx<=34 Then
    If t=33 Then
     st(my,mx)=32
     Do While x\16<>mx-px-2 Or y\16<>my-py-1
      If x\16<mx-px-2 Then x=x+16
      If x\16>mx-px-2 Then x=x-16
      If y\16<my-py-1 Then y=y+16
      If y\16>my-py-1 Then y=y-16
      If x<80 And px>1 Then x=x+16:px=px-1
      If y<88 And py>1 Then y=y+16:py=py-1
      If x>88 And px<35-12 Then x=x-16:px=px+1
      If y>96 And py<32-15 Then y=y-16:py=py+1
     Loop
    Else
     If t=253 Then Tr=Tr+1: xh(Tr)=mx: yh(Tr)=my: t=32
     ST(my,mx)=t
    EndIf
   EndIf
 Next mx,my
 Close #1
 If Tr>0 Then i=Rnd(55)*Tr+1: ST(yh(i),xh(i))=52
End Sub

Sub YOU(C)
 If start=0 Then
  Sprite paste bs,x,y: Sprite paste C,x,y
 ElseIf start>1 And start<=30 Then
  If start=29 Then
   c=1:nextroom=1
   room=room+1: If psgmusic=1 Then StopMusic
   For t=20 To 10000 Step 2
    If t Mod 200=0 Then
     c=c+2: If c>8 Then c=1
     Sprite paste 20,x,y: Sprite paste c,x,y
    EndIf
    If t Mod 10=0 Then Sound t+Rnd(25)*t,1
   Next t
   Sprite paste 20,x,y: Sprite paste 27,x,y
   For t=5000 To 10000 Step 40: tt=Rnd(15)*t+20: Tone tt,tt,1: Next t
   Sprite paste 20,x,y: Sprite paste 28,x,y
   For t=10000 To 18000 Step 40: tt=Rnd(15)*t+20: Tone tt,tt,1: Next t
   Sprite paste 20,x,y: Pause(200): If psgmusic=1 Then UnloadMusic
  EndIf
 EndIf
End Sub

Sub MapScan
 Local xx,yy,t,tt,tp,xc,yc,tps
 xz=px+1:yz=py+1
 If mv>=0 And start<2 Then tps=1 Else tps=0
 For yy = ya To yb
  For xx = xa To xb
   t=st(yy+yz,xx+xz)
   xc=xx*16: yc=yy*16
   If tps=1 Or t=32 Then Sprite paste bs,xc,yc
   If t=52 Then
    Sprite paste 20,xc,yc
    If start>1 And start<=30 Then x=xc: y=yc: st(yy+yz,xx+xz)=32
   EndIf
   If t>32 And start<2 Then
    If t>=500 Then
     If t+500+32<=sprmax Then Sprite paste t-500-32,xc,yc
    ElseIf t<=sprmax Then
     Sprite paste t-32,xc,yc
    EndIf
    If (t-32>=31 And t-32<=87) Or (t>=200 And t<=220) Then
     addEnemy(xc+16+fixx,yc+fixy,0,t-32,4): st(yy+yz,xx+xz)=32
     'addEnemy(xc,yc,0,t-32,4): st(yy+yz,xx+xz)=32
    EndIf
   EndIf
  Next xx,yy
  If start=2 Then RedrawEnemies
  If start=1 Then
   start=0
   Sprite paste 28,x,y
   For t=18000 To 10000 Step -40: tt=Rnd(15)*t+20: Tone tt,tt,1: Next t
   Sprite paste 27,x,y
   For t=10000 To 5000 Step -40: tt=Rnd(15)*t+20: Tone tt,tt,1: Next t
  EndIf
End Sub

' TURN ON ENEMY
Sub ADDENEMY(xg,yg,tp,ch,en)
 Local tc,ok,i,xb,yb,t,tt
 tc=0: ok=0: Do While (tc<=maxg And ok=0)
  tc=tc+1: If ae(tc)=0 Then
   ok=1: xh(tc)=0: yh(tc)=0
   If ((ch>=28 And ch<=87) Or (ch>=200-32 And ch<=220-32)) Then
    If tp<>13 Then
     If (ch>=31 And ch<=33) Then 'GHOST GEN
      tp=0: en=(ch-30)*3
     ElseIf (ch>=34 And ch<=49) Then 'GHOST
      tp=1
     ElseIf (ch>=50 And ch<=52) Then 'GRUNT GEN
      tp=2: en=(ch-49)*3
     ElseIf (ch>=53 And ch<=60) Then 'GRUNT
      tp=3: en=6
     ElseIf (ch>=200-32 And ch<=202-32) Then 'DEMON GEN
      tp=4: ch=ch-(200-32)+50: en=(ch-49)*3
     ElseIf (ch>=61 And ch<=76) Then 'DEMON
      tp=5: en=9
     ElseIf (ch>=203-32 And ch<=205-32) Then 'SORCERER GEN
      tp=6: ch=ch-(203-32)+50: en=(ch-49)*3
     ElseIf (ch>=84 And ch<=87) Then 'SORCERER
      tp=7: en=6
     ElseIf (ch>=81 And ch<=83) Then 'SLIME
      tp=9: en=999
     ElseIf (ch>=77 And ch<=80) Then 'DEAD
      tp=11: en=250
     EndIf
    Else
     'DEMON FIRE SIDE
     If ch=61 Then xh(tc)= 0: yh(tc)=-8
     If ch=63 Then xh(tc)= 8: yh(tc)=-8
     If ch=65 Then xh(tc)= 8: yh(tc)= 0
     If ch=67 Then xh(tc)= 8: yh(tc)= 8
     If ch=69 Then xh(tc)= 0: yh(tc)= 8
     If ch=71 Then xh(tc)=-8: yh(tc)= 8
     If ch=73 Then xh(tc)=-8: yh(tc)= 0
     If ch=75 Then xh(tc)=-8: yh(tc)=-8
     en=1
    EndIf
   EndIf
   xe(tc)=xg+xh(tc): ye(tc)=yg+yh(tc): ae(tc)=3: te(tc)=tp: ce(tc)=ch
   en(tc)=en: If tp=13 Then
    ae(tc)=1: xb=xe(tc)/16+xz: yb=ye(tc)/16+yz: t=0.5:i=32:tt=0
    For t=0 To 0.5 Step 0.5
    If st(yb,xb)<>i Or st(yb-t,xb)<>i Or st(yb,xb-t)<>i Or st(yb-t,xb-t)<>i Then
     tt=1
    EndIf
    Next t: If tt=1 Then ae(tc)=0 Else PlaySFX(360,-100,10,0,45)
   EndIf
  EndIf
 Loop
End Sub

' REMOVE ENEMY
Sub RETENEMY(n,gr)
 Local t,xt,yt
 If ae(n)=0 Then Exit Sub
 xt=xe(n)/16+xz: yt=ye(n)/16+yz
 If xt>0 And yt>0 And xt<37 And yt<37 Then
  If st(yt,xt)<88+32 Or st(yt,xt)>103+32 Then
   If te(n)<>13 Then
    If gr<>32 Then
     If te(n)=4 Then t=ce(n): gr=t-50+200-32
     If te(n)=6 Then t=ce(n): gr=t-50+203-32
     gr=gr+32
    EndIf: st(yt,xt)=gr
   EndIf
  EndIf: If xe(n)<160 And ye(n)<MM.VRes-24 Then Sprite paste bs,xe(n),ye(n)
 EndIf
 ae(n)=0: en(n)=0: xe(n)=-64: ye(n)=-64: xh(n)=0: yh(n)=0
End Sub

' ENEMIES ROTINES
Sub PUTENEMY(n)
 Local xt,yt,tx,ty,txx,tyy,sx,sy,t,tt,tee,tp,gtp,xa,ya,cee,xb,yb,xc,yc,ok
 If en(n)<=0 Then retenemy(n,32): Exit Sub
 xt=xe(n): yt=ye(n)
 If xt<-15 Or xt>168 Or yt<-15 Or yt>MM.VRes-24 Then retenemy(n,ce(n)): Exit Sub
 cee=ce(n): enn=en(n): tee=te(n): xa=xt: ya=yt
 xb=Cint(xa/16+xz): yb=Cint(ya/16+yz)

 If tee<>13 Then st(yb,xb)=32
 gtp=0: If tee>1 Then gtp=19

 If tee Mod 2 = 0 Then ' GENERATORS
  If xa+15>=x And xa<=x+15 And ya+15>=y And ya<=y+15 Then
   Sprite paste bs,xa,ya: enn=enn-Cfig
  Else
   Sprite paste bs,xa,ya: tt=31+gtp
   If enn>=4 Then tt=32+gtp
   If enn>=7 Then tt=33+gtp
   Sprite paste tt,xa,ya: st(yb,xb)=cee+500: cee=tt
  EndIf
  ' GENERATE ENEMIES
  If mv=0 Then
   If Rnd(1)>0.50 Then
    tx=Int(Rnd(320)*3)-1: ty=Int(Rnd(120)*3)-1
    If st(yb+ty,xb+tx)=32 Then
     tt=34
     If tee=2 Then tt=53
     If tee=4 Then tt=61
     If tee=6 Then tt=84
     addenemy(xa+tx*16,ya+ty*16,tee+1,tt,en(n)+1+tee/2)
    EndIf
   EndIf
  EndIf
 Else ' WALKING ENEMIES
  If tee<>9 And tee<>13 Then
   xc=Cint(x/16)*16: yc=Cint(y/16)*16
   sx=0: sy=0
   If ya>yc Then
    cee=34: ya=ya-spd: sy=-spd
    If tee=3 Then cee=53 Else If tee=7 Or tee=11 Then cee=84
   ElseIf ya<yc Then
    cee=42: ya=ya+spd: sy=spd
    If tee=3 Then cee=57 Else If tee=7 Or tee=11 Then cee=86
   EndIf
   If xa>xc Then
    cee=46: xa=xa-spd: sx=-spd
    If tee=3 Then cee=59 Else If tee=7 Or tee=11 Then cee=87
    If ya>yc Then
     cee=48: If tee=3 Then cee=59 Else If tee=7 Or tee=11 Then cee=87
    ElseIf ya<yc Then
     cee=44: If tee=3 Then cee=59 Else If tee=7 Or tee=11 Then cee=87
    EndIf
   ElseIf xa<xc Then
    cee=38+tp: xa=xa+spd: sx=spd
    If tee=3 Then cee=55 Else If tee=7 Or tee=11 Then cee=85
    If ya>yc Then
     cee=36: If tee=3 Then cee=55 Else If tee=7 Or tee=11 Then cee=85
    ElseIf ya<yc Then
     cee=40: If tee=3 Then cee=55 Else If tee=7 Or tee=11 Then cee=85
    EndIf
   EndIf
   If tee=5 Then cee=cee+27 Else If tee=11 Then cee=cee-7
   If ae(n)>1 Then xa=xt: ya=yt: ae(n)=ae(n)-1
   'RELEASE DEMON FIRE
   If tee=5 And Rnd(75)*1>0.70 And ae(n)=1 And DFire=0 Then
    ae(n)=2: Dfire=n: xa=xt:ya=yt
   EndIf
  ElseIf tee=9 Then ' SLIME RANDOM WALK
   cee=81+Rnd(40)*2: mx=spd*(Int(Rnd(20)*3)-1): my=spd*(Int(Rnd(70)*3)-1)
   xa=xa+mx: sx=mx: ya=ya+my: sy=my
  ElseIf tee=13 Then 'DEMON FIRE
   xa=xa+xh(n)*2: ya=ya+yh(n)*2: cee=28
  EndIf

  ' ENEMY OBJECT COLISIONS
  xb=xa/16+xz: yb=ya/16+yz: t=-0.5: i=32: tt=0
 If xa Mod 16=0 And ya Mod 16=0 Then
  If sw=1 Then
   xb=Cint(xa/16+xz): yb=Cint(ya/16+yz)
   If st(yb,xb)<>i Then xa=xt: tt=1: xb=Cint(xa/16+xz)
   If st(yb,xb)<>i Then ya=yt: tt=1: yb=Cint(ya/16+yz)
  Else
   If st(yb,xb)<>i Then ya=yt: tt=1: yb=Cint(ya/16+yz)
   If st(yb,xb)<>i Then xa=xt: tt=1: xb=Cint(xa/16+xz)
  EndIf
 Else
  If sw=1 Then
   If st(yb+t,xb+t)<>i Or st(yb,xb)<>i Or st(yb,xb+t)<>i Or st(yb+t,xb)<>i Then
    xa=xt: tt=1: xb=xa/16+xz: EndIf
   If st(yb+t,xb+t)<>i Or st(yb,xb)<>i Or st(yb,xb+t)<>i Or st(yb+t,xb)<>i Then
    ya=yt: tt=1: yb=ya/16+yz: EndIf
  Else
   If st(yb+t,xb+t)<>i Or st(yb,xb)<>i Or st(yb,xb+t)<>i Or st(yb+t,xb)<>i Then
    ya=yt: tt=1: yb=ya/16+yz: EndIf
   If st(yb+t,xb+t)<>i Or st(yb,xb)<>i Or st(yb,xb+t)<>i Or st(yb+t,xb)<>i Then
    xa=xt: tt=1: xb=xa/16+xz: EndIf
  EndIf
 EndIf
  If tee=13 And tt=1 Then
   Sprite paste bs,xa,ya: xe(n)=xa: ye(n)=ya: retenemy(n,32): Exit Sub
  EndIf

  ' ENEMY ON PLAYER
  If xt+18>=x And xt<=x+18 And yt+18>=y And yt<=y+18 Then
   xa=xt: ya=yt
   If swi=0 Or tee=1 Then
    If PTypeA=1 Then PlaySFX(200,-20,25,0,10)
    If PTypeA=2 Then PlaySFX(370,-20,195,0,15)
    If PTypeA=3 Then PlaySFX(320,-25,135,0,35)
    If PTypeA=4 Then PlaySFX(290,-20,115,0,5)
   EndIf
   If tee=9 Or tee=11 Or tee=13 Then
    enn=enn-5: Energy=Energy-tee\2+Carm\2
   Else
    Energy=Energy-enn+Carm\2
   EndIf
   If mov<>0 Then Enn=Enn-Cfig\2: Anim=1
   If tee=1 Then     'GHOST ATTACK
    Sprite paste bs,xt,yt: Sprite paste bs,xe(n),ye(n): xe(n)=xa: ye(n)=ya
    retenemy(n,32): For t=18000 To 5000 Step -120: tt=Rnd(15)*t+20
    Tone tt,tt,1: Next t: Exit Sub
   ElseIf tee Mod 2=1Then 'OTHER ATTACKS
    Sprite paste bs,xt,yt: If tee=1 Or tee=3 Or tee=5 Then i=swi Else i=0
    If cee+i<=87 Then Sprite paste cee+i,xt,yt
    If swi=0 Then
     If tee=3 Then PlaySFX(200,-50,40,0,40)
     If tee=5 Then PlaySFX(120,-20,30,0,15)
     If tee=7 Then PlaySFX(400,-80,240,0,40)
    EndIf
    If tee=9 Then PlaySFX(2300,20,0,2400,10)
    If tee=11 Then PlaySFX(3200,-500,540,0,5)
    If tee<>13 Then st(Cint(yt/16+yz),Cint(xt/16+xz))=cee+500
   EndIf
  Else ' FREE ENEMY
   If tee=1 Or tee=3 Or tee=5 Then i=swi Else i=0
   If xt>160 Then xt=160
   Sprite paste bs,xt,yt: If en(n)>0 And xa<=160 Then Sprite paste cee+i,xa,ya
   If tee<>13 Then st(yb,xb)=cee+500
  EndIf
 EndIf
 xe(n)=xa: ye(n)=ya: ce(n)=cee: en(n)=enn
 If enn<=0 And xt<=160 Then Sprite paste bs,xt,yt: retenemy(n,32)
End Sub

START:

speeds=2: snd=0: energy=MaxEn: Anim=1: side=3: TSPD=100
bg=1: time=0: bs=104: Plu=0:Pld=0:Pll=0:Plr=1:nowalk=0

'RESET SOUND
For t=1 To ms: snd(t)=0: Next t

'RESET ENEMIES
For t=1 To maxg
 xe(t)=-64: ye(t)=-64: ae(t)=0: te(t)=0: xh(t)=0: yh(t)=0
Next t

A$="": If room<10 Then A$="0"
LoadMap(".\maps\room"+A$+Str$(room)+".map")
'PlayRAW(".\raw\findout.raw",0,1.6)

If psgmusic=1 Then
 song=song+1: If song>4 Then song=1
 i=room
 If i=4 Then
  songf$="treasure"
 Else
  songf$="song"+Str$(song)
 EndIf
 LoadVGM(".\vgm\"+songf$+".vgm")
 PlayVGM
 'good - 1,2,3,4,8,treasure
 'osc - 5,6
 'slo - 7,treassms
 ChangeSpeed(1)
 SetIntMusic(10)
EndIf

SetTick 15,IntSFX,1

nextroom=0: start=1

If FirstLoad=1 Then FirstLoad=0: Cls
LoadBMP(".\bmp\panel64.bmp"),176
Font #1: Font Unload #4: Font Load ".\fnt\gauntnes.fnt" As #4

Font #4: Color 7: Print @(241-8*Len(Str$(room)),29) room
Font #1: Font Unload #4: Font Load ".\fnt\gauntmin.fnt" As #4: Font #4
GAMELOOP:
If nextroom=1 Then nextroom=0: GoTo LOADSCREEN

' KEYBOARD / GAMEPAD ROTINES
If start=0 Then k=KeyDown Else k=0
mv=0
If nowalk>0 Then k=0: nowalk=nowalk-1

'ReadSNES(1)
mov=0: spd=0: tspd=tspd+tac+1

If k=80 And pause=0 Then
 PAUSE=1
 Do While KeyDown=80
 Loop
 Do While KeyDown<>80
 Loop
Else
 PAUSE=0
EndIf

If tspd>4-(cspd) Then
 tspd=0: spd=8: xx=x: yy=y: If Anim=0 Then anim=1 Else anim=0
EndIf
spx=0: spy=0
If k=128 Or k=55 Or k=56 Or k=57 Or SNES_U=1 Then
 y=y-spd: spy=-spd: side=7: mov=1: Plu=1: Pld=0
 If k=128 Or k=56 Then Pll=0: Plr=0
EndIf
If k=129 Or k=49 Or k=50 Or k=51 Or SNES_D=1 Then
 y=y+spd: spy=spd:  side=1: mov=1: Pld=1: Plu=0
 If k=129 Or k=50 Then Pll=0: Plr=0
EndIf
If k=130 Or k=49 Or k=52 Or k=55 Or SNES_L=1 Then
 x=x-spd: spx=-spd: side=5: mov=1: Pll=1: Plr=0
 If k=130 Or k=52 Then Pld=0: Plu=0
EndIf
If k=131 Or k=51 Or k=54 Or k=57 Or SNES_R=1 Then
 x=x+spd: spx=spd:  side=3: mov=1: Plr=1: Pll=0
 If k=131 Or k=54 Then Pld=0: Plu=0
EndIf
If k=27 Then
 Mode 1: If psgmusic=1 Then UnloadMusic
 End
EndIf
If k=32 And fire=0 Then
 fire=1
 If PtypeA=1 Then PlaySFX(600,-120,50,0,45)
 If PtypeA=2 Then PlaySFX(700 ,-100,120,0,30)
 If PtypeA=3 Then PlaySFX(1000,-190,30,0,15)
 If PtypeA=4 Then PlaySFX(3500,-500,1500,0,11)
 xfs=0:yfs=0: shotv=0: tac=0
 If Plu=1 Then yfs=-8: xs= 9
 If Pld=1 Then yfs= 8: xs=13
 If Pll=1 Then xfs=-8: xs=15
 If Plr=1 Then xfs= 8: xs=11
 If Plu=1 And Plr=1 Then xs=10
 If Plu=1 And Pll=1 Then xs=16
 If Pld=1 And Plr=1 Then xs=12
 If Pld=1 And Pll=1 Then xs=14
 xf=x: yf=y: fstart=0
 If PTypeA=1 Then xf=x-xfs: yf=y-yfs
 If PTypeA=2 Then xf=x+xfs: yf=y+yfs
EndIf

' PLAYER FIRE
If fire=1 Then
 xfa=xf: yfa=yf: fstart=fstart+1: If PtypeA=1 Then xs=xs+1: If xs>16 Then xs=9
 shotv=shotv+tac+1: If shotv>=5-cshs Then xf=xf+xfs: yf=yf+yfs: shotv=0

 ' FIRE COLISION
 For tx=0 To 1
  For ty=0 To 1
   txx=(xf-tx*8+xfs)/16+xz: tyy=(yf-ty*8+yfs)/16+yz: US=st(tyy,txx)
   If US<>32 And US<250 Then
    If US=106+32 Then
     For t=500 To 12000 Step 90: a=Rnd(35)*t+20: Sound a,1: Next t
     st(tyy,txx)=32: mv=-2: fstart=2
    EndIf
    If fstart>2 Then
     If xfa<=160 Then Sprite paste bs,xfa,yfa
     If xf<=160 Then
      Sprite paste bs,xf,yf: Sprite paste xs,xf,yf : Sprite paste 27,xf,yf
     EndIf
    EndIf
    fire=2
   EndIf
 Next ty,tx

 ' FIRE OFFSCREEN?
 If xf<-16 Or xf>=158 Or yf<-16 Or yf>=MM.VRes-24 Then
  fire=2: If xf<=160 Then Sprite Paste bs,xfa,yfa
 EndIf

 ' FIX FIRE TO NOT CLEAR A WALL
 If fstart>1 And xf<=160 Then Sprite paste xs,xf,yf

' FIRING ENEMIES
 For n=1+sw To maxg Step 2
  If ae(n)>0 Then
   xt=xe(n): yt=ye(n)
   If xt+15>=xf And xt<=xf+15 And yt+15>=yf And yt<=yf+15 Then
    en(n)=en(n)-(Csht*2): xtf=xt:ytf=yt:cef=ce(n): tt=te(n)
    If tt Mod 2=1 Then Sprite paste cef,xt,yt
    Sprite paste 27,xf,yf
    If tt Mod 2=0 Then ' GENERATORS
     For t=500 To 3000-TT*100 Step 30: a=Rnd(15)*t+20: Sound a,1: Next t
    Else ' ENEMIES
     For t=5000-TT*250 To 16000-TT*1000 Step 120
      a=Rnd(15)*t+20: Sound a,1
     Next t
    EndIf
    If en(n)<=0 Then
     score=score+(te(n)*5+5)
     retenemy(n,32): fire=2: Sprite paste 27,xf,yf
    Else
     fire=3
    EndIf
   EndIf
  EndIf
 Next n

EndIf

' PLAYER COLISION
blk=0
For tx=0 To 1
 For ty=0 To 1
  US=st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)-32
  If US>0 Then
   If US=24 Then ' KEY
    score=score+15: Key=Key+1: If SAVEKE=0 Then SAVEKE=1
    If key>9 Then
     key=9
    Else
     PlaySFX(1500,-250,800,0,50):mv=-1:st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)=32
    EndIf
   ElseIf US=17 Then ' TREASURE
    score=score+100: If GETTRE=0 Then GETTRE=1
    PlaySFX(1000,1500,0,11000,50): mv=-1
    st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)=32
   ElseIf (US=22 Or US=23) And (key>0) Then ' DOOR
    key=key-1: PlaySFX(25,15,0,150,25)
    OpenDoor((x-tx*spd)/16+xz,(y-ty*spd)/16+yz)
   ElseIf US=21 Or US=25 Then ' FOOD
    score=score+25: PlaySFX(25,50,0,300,15): PlaySFX(300,-30,25,0,10)
    Energy=Energy+hpg: If Energy>MaxEn Then Energy=MaxEn: mv=-1
    st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)=32
   ElseIf US=26 Then ' POTION
    score=score+25: bomb=bomb+1: If SAVEPO=0 Then SAVEPO=1
    If bomb>9 Then
     bomb=9
    Else
     PlaySFX(650,100,0,850,50): mv=-1: st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)=32
    EndIf
   ElseIf US=20 Then ' EXIT
    start=30: mv=-1
   ElseIf US=105 Then ' FREEZE FLOOR
    st((y-ty*spd)/16+yz,(x-tx*spd)/16+xz)=32
    For t=12000 To 500 Step -40: a=Rnd(35)*t+20: Sound a,1: Next t
    mv=-1: nowalk=40
   EndIf
   x=xx: y=yy: anim=0: blk=1
  EndIf
Next ty,tx

If mov=1 Then
 If fstart<4 And fire>0 Then anim=1
 If spd>0 And xx<=160 Then Sprite paste bs,xx,yy: If blk=0 Then YOU(side+Anim)
Else
 Anim=0
EndIf

' BLITTING / SCROLL / MAP LIMITS
spd=16
blit=0: bx=0: by=0: u=0:d=0:l=0:r=0:i=0
If x<80 And px>1 Then MV=7: bx=spd:l=spd/softs: px=px-1
If y<88 And py>1 Then MV=1: by=spd:u=spd/softs: py=py-1
If x>88 And px<35-12 Then MV=3: bx=-spd:r=spd/softs: px=px+1
If y>96 And py<32-15 Then MV=5: by=-spd:d=spd/softs: py=py+1
If mv<>0 Then
 If u>0 And r>0 Then MV=2
 If u>0 And l>0 Then MV=8
 If d>0 And r>0 Then MV=4
 If d>0 And l>0 Then MV=6
 If start<>1 Then
  x=x+bx: y=y+by: Sprite paste bs,x-bx/2,y-by/2
  Sprite paste side+Anim,x-bx,y-by
 EndIf
 If Anim=0 Then anim=1 Else anim=0
 For t=1 To softs
  BLIT r,d,l,u,MM.HRes-Abs(bx/softs)-64, MM.VRes-Abs(by/softs)-8
 Next t
 YOU(side+Anim): blit=1
EndIf

' ADJUST MAP SCAN SIZE
ya=0: yb=12: xa=0: xb=10: sgx=0: sgy=0: fixx=0:fixy=0
If start=1 Then fixx=-16: MapScan
If mv=1 Then ya=0:yb=0:sgy=spd:fixx=-16:fixy=-16: MapScan
If mv=2 Then
 sgx=-spd: sgy=spd:fixx=0:fixy=-16
 xa= 0: xb=10: ya=0: yb=0: MapScan
 xa=10: xb=10: ya=0: yb=12: MapScan
EndIf
If mv=3 Then xa=10:xb=10:sgx=-spd:fixx=0: MapScan
If mv=4 Then
 sgx=-spd: sgy=-spd:fixx=0:fixy=16
 xa=10: xb=10: ya=0: yb=12: MapScan
 xa= 0: xb=10: ya=12: yb=12: MapScan
EndIf
If mv=5 Then ya=12:yb=12:sgy=-spd:fixx=-16:fixy=16: MapScan
If mv=6 Then
 sgx=spd: sgy=-spd:fixx=-32:fixy=16
 xa= 0: xb=10: ya=12: yb=12: MapScan
 xa= 0: xb= 0: ya=0: yb=12: MapScan
EndIf
If mv=7 Then xa=0: xb=0:sgx=spd: fixx=-32: MapScan
If mv=8 Then
 sgx=spd: sgy=spd:fixx=-32:fixy=-16
 xa= 0: xb= 0: ya=0: yb=12: MapScan
 xa= 0: xb=10: ya=0: yb=0: MapScan
EndIf

If mv=-1 Or mv=-2 Then
 If mv=-1 Then
  xa=(x+x Mod 16)/16-2: ya=(y+y Mod 16)/16-2
  xb=(x+x Mod 16)/16+2: yb=(y+y Mod 16)/16+2
 Else
  xa=(xf+xf Mod 16)/16-2: ya=(yf+yf Mod 16)/16-2
  xb=(xf+xf Mod 16)/16+2: yb=(yf+yf Mod 16)/16+2
 EndIf
 If ya<0 Then ya=0
 If xa<0 Then xa=0
 If xa>10 Then xa=10
 If xb>10 Then xb=10
 If ya>12 Then ya=12
 If yb>12 Then yb=12
 MapScan
EndIf

spd=8: If start>0 Then start=start-1
If fstart<4 And fire>0 Then anim=1
YOU(side+Anim): fps=1000\(Timer-TI): TI=Timer
Do While pausetimer>Timer And mv=0
Loop
pausetimer=Timer+50

tac=tac+1: If tac>2 Then tac=0: If tic=1 Then tic=0 Else tic=1

' COUNT ENEMIES
actg=0: cntg=0
For t=1 To maxg
 If ae(t)>0 Then actg=actg+1:  If cntg<t Then cntg=t
Next t

' SCROLL FIX - ENEMIES ETC
If blit=1 Then
 If fire>0 Then xf=xf+sgx: yf=yf+sgy
 For t=1 To cntg
  If ae(t)>0 Then
   xt=xe(t)+sgx: yt=ye(t)+sgy
   If xt>-16 And xt<160 And yt>-16 And yt<MM.VRes-24 Then
    tee=te(t): If tee=1 Or tee=3 Or tee=5 Then i=swi Else i=0
    Sprite paste bs,xt,yt: Sprite paste ce(t)+i,xt,yt
   EndIf: xe(t)=xt: ye(t)=yt
  EndIf: Next t
EndIf

'REFRESH BOTTOM BAR
If Timer > EnTime Then
 EnTime=Timer+1000: energy=energy-1: tt=(PTypeA-1)*40: Color CoP
 Print @(216,72+tt) Format$(energy,"%05g");
 Print @(177,72+tt) Format$(score,"%06g");
 If key>0 Then For t=1 To key:Color 6:Print @(171+t*5,80+tt) Chr$(46);:Next t
 If bomb>0 Then For t=1 To bomb:Color 3:Print @(241-t*5,80+tt) Chr$(47);:Next t
 If fps<10 Then fp$="0" Else fp$=""
 If actg<10 Then A$="0" Else A$=""
 Print @(230,210) CLR$(6);fp$;FPS;: Print @(215,210) A$;actg;
EndIf

If fire>=2 Then
 If fstart>1 Then If xf<=160 Then Sprite paste bs,xf,yf
 If fire=3 Then If xtf<=160 Then Sprite paste cef,xtf,ytf
 fire=0: xf=-64: yf=-64
EndIf

' ENEMIES ON SCREEN
t=0
If actg>20 Then t=2
If actg>30 Then t=4
If actg>40 Then t=6
eini=eini+1: stp=3+t: Dfire=0
If eini>stp+2+t Then eini=1: If swi=1 Then swi=0 Else swi=1
For t=eini To cntg Step stp
 If ae(t)>0 Then PutEnemy(t)
Next t
t=dfire: If t>0 Then addenemy(xe(t)+xh(t)*2,ye(t)+yh(t)*2,13,ce(t),1): dfire=0

If fstart>1 And fire=1 Then
 If xf<=160 Then
  Sprite paste bs,xf,yf: If fstart<4 Then Sprite paste side+Anim,x,y
 EndIf
EndIf
If sw=0 Then sw=1 Else sw=0

If GETTRE=1 Then GETTRE=2: VoiceOver("TREASURE 100 POINTS","100POIN")
If SAVEKE=1 Then SAVEKE=2: VoiceOver("SAVE KEYS TO OPEN DOORS","OPENDOOR")
If SAVEPO=1 Then SAVEPO=2: VoiceOver("SAVE POTIONS FOR LATER USE","SAVEPOTI")

GoTo GAMELOOP
